#include "stdafx.h"
#include "plugin.h"

#define IDS_MENU_TEXT 1
#define IDS_STATUSMESSAGE 2
#define IDI_ICON 101

HWND	g_hOutputBarWnd = NULL;
HWND	g_hTopWnd		= NULL;
HHOOK	g_hook			= NULL;
CEdit*	m_pEdit			= NULL;

//OutputBařpR[obN֐
BOOL CALLBACK EnumChildProc(HWND hWnd , LPARAM lp)
{
	WCHAR cn[128];
	GetClassName( hWnd, cn, 128 );
	if( !lstrcmp( cn, L"TPanel" ) )
	{
		EnumChildWindows(hWnd , EnumChildProc , lp);
		return FALSE;
	}
	else if( !lstrcmp( cn, L"TMemo" ) )
	{
		g_hOutputBarWnd = hWnd;
		m_pEdit = (CEdit*)CEdit::FromHandle( hWnd );
		return FALSE;
	}

	return TRUE;
}

//}EX̃tbN֐
LRESULT CALLBACK MouseProc( int nCode, WPARAM wParam, LPARAM lParam )
{
	if( nCode < 0 )
		return CallNextHookEx(NULL, nCode, wParam, lParam);

	MOUSEHOOKSTRUCT *mmsg;  
	mmsg = (MOUSEHOOKSTRUCT *)lParam;
	if( g_hOutputBarWnd != mmsg->hwnd )
		return CallNextHookEx(NULL, nCode, wParam, lParam);
	else if( WM_LBUTTONDBLCLK != wParam )
		return CallNextHookEx(NULL, nCode, wParam, lParam);

	//Jbg̈ʒȗɑIʒu擾
	int iStart, iEnd;
	m_pEdit->GetSel( iStart, iEnd );
	//eLXgSĎ擾
	CString inputedText;
	m_pEdit->GetWindowText( inputedText );
	
	//DCꂽs̕؂o
	int iFind = inputedText.Find( '\n', iStart );
	//Ẽg
	CString sSelectLine = iFind > - 1 ? inputedText.Left( iFind - 1 ): inputedText;
	//̃g
	iFind = sSelectLine.ReverseFind( '\n' );
	sSelectLine = iFind > - 1 ? sSelectLine = sSelectLine.Mid( iFind + 1 ) : sSelectLine;
	
	if( sSelectLine.IsEmpty() )
		return 1;

	int iLeftParenPos = sSelectLine.Find( '(', 0 );
	int iRightParenPos = sSelectLine.Find( ')', 0 );
	if( -1 == iLeftParenPos || -1 == iRightParenPos )
		return 1;

	//Iꂽs${filepath}\(${linenum}\).+ɂȂĂ邱ƂmF
	CString strPath = sSelectLine.Left( iLeftParenPos );
	CString strLine = sSelectLine.Mid( iLeftParenPos + 1, iRightParenPos - iLeftParenPos - 1 );
	//t@CJ
	Editor_LoadFile( g_hTopWnd, strPath );
	//Jt@C̍sɔ(_sȂ̂-1Ă)
	int iLine = _ttoi( strLine );
	POINT_PTR* pPtr= new POINT_PTR();
	pPtr->x = 0;
	pPtr->y = iLine - 1;
	Editor_SetCaretPos( g_hTopWnd, POS_LOGICAL, pPtr );
	delete pPtr;

	return 1;
}

// -----------------------------------------------------------------------------
// OnCommand
// vOCsɌĂяo܂
// p[^
//   hwnd: EBhẼnh
EXTERN_C void WINAPI OnCommand(HWND hwnd)
{

	//g_hook`FbN(vOCOn/Off)ɎgpĂ̂ŁA
	//̃nhOsB
	if( g_hook )
	{
		//tbN̉
		UnhookWindowsHookEx( g_hook );
		g_hook = NULL;
	}
	else
	{
		//}EXtbN̐ݒ
		g_hook = SetWindowsHookEx( WH_MOUSE, MouseProc, NULL, GetCurrentThreadId() );
	}

	if( !g_hTopWnd  )
	{
		g_hTopWnd = hwnd;
	}
}


void _InitPlugin( HWND hwnd )
{
	if( m_pEdit )
		return;

	//OutputBar̎擾s
	EnumChildWindows(hwnd , EnumChildProc , (LPARAM)hwnd);
	if( !m_pEdit )
	{
		//OutputBar擾oȂꍇA쐬̉\̂
		//x\ĂȂ\̂ŁAĊJɍēxs
		Editor_OutputString( hwnd, NULL,FLAG_OPEN_OUTPUT );
		Editor_OutputString( hwnd, NULL,FLAG_CLOSE_OUTPUT );
		EnumChildWindows(hwnd , EnumChildProc , (LPARAM)hwnd);
	}

	//vOC̏lON
	if( m_pEdit && !g_hook )
	{
		OnCommand( hwnd );
	}

}

// -----------------------------------------------------------------------------
// QueryStatus
//   vOCs\A܂̓`FbNꂽԂ𒲂ׂ܂
// p[^
//   hwnd:      EBhẼnh
//   pbChecked: `FbN̏
// ߂l
//   s\łTrueԂ܂

EXTERN_C BOOL WINAPI QueryStatus(HWND hwnd, LPBOOL pbChecked)
{
/**
* *pbCheckedɐݒ肵luj[\Ƃ̃`FbN̏ԁv
* T:`FbNLAF:`FbN
*
* ߂ls\ǂ
* T:s\AF:ss(O[AEg)
*
*/
	_InitPlugin( hwnd );
	//tbN̗LŁALԂ𔻒fB
	*pbChecked = g_hook ? TRUE : FALSE;

	//OutputBar̎擾ʂŁAs̉ۂ𔻒fB
	return m_pEdit ? TRUE : FALSE;
}

// -----------------------------------------------------------------------------
// GetMenuTextID
//   j[ɕ\eLXg̃\[Xʎq擾܂
// ߂l
//   \[Xʎq

EXTERN_C UINT WINAPI GetMenuTextID()
{
	return IDS_MENU_TEXT;
}

// -----------------------------------------------------------------------------
// GetStatusMessageID
//   c[`bvɕ\eLXg̃\[Xʎq擾܂
// ߂l
//   \[Xʎq

EXTERN_C UINT WINAPI GetStatusMessageID()
{
	return IDS_STATUSMESSAGE;
}

// -----------------------------------------------------------------------------
// GetIconID
//   c[o[ɕ\ACR̃\[Xʎq擾܂
// ߂l
//   \[Xʎq

EXTERN_C UINT WINAPI GetIconID()
{
	return IDI_ICON;
}

// -----------------------------------------------------------------------------
// OnEvents
//   CxgɌĂяo܂
// p[^
//   hwnd:   EBhẼnh
//   nEvent: Cxg̎
//   lParam: bZ[WL̒ǉ
// l
//   EVENT_CREATE:             GfB^N
//   EVENT_CLOSE:              GfB^I
//   EVENT_CREATE_FRAME:       t[쐬ꂽ
//   EVENT_CLOSE_FRAME:        t[jꂽ
//   EVENT_SET_FOCUS:          tH[JX擾
//   EVENT_KILL_FOCUS:         tH[JX
//   EVENT_FILE_OPENED:        t@CJ
//   EVENT_FILE_SAVED:         t@Cۑ
//   EVENT_MODIFIED:           XV̏ԂύXꂽ
//   EVENT_CARET_MOVED:        J[\ړ
//   EVENT_SCROLL:             XN[ꂽ
//   EVENT_SEL_CHANGED:        I͈͂ύXꂽ
//   EVENT_CHANGED:            eLXgύXꂽ
//   EVENT_CHAR:               ͂ꂽ
//   EVENT_MODE_CHANGED:       ҏW[hύXꂽ
//   EVENT_DOC_SEL_CHANGED:    ANeBuȕύXꂽ
//   EVENT_DOC_CLOSE:          
//   EVENT_TAB_MOVED:          ^uړꂽ
//   EVENT_CUSTOM_BAR_CLOSING: JX^o[悤Ƃ
//   EVENT_CUSTOM_BAR_CLOSED:  JX^o[
//   EVENT_TOOL_BAR_CLOSED:    c[o[
//   EVENT_TOOL_BAR_SHOW:      c[o[\ꂽ
//   EVENT_IDLE:               ACh

EXTERN_C void WINAPI OnEvents(HWND hwnd, UINT nEvent, LPARAM lParam)
{
	
	return;
}

// -----------------------------------------------------------------------------
// PluginProc
//   vOCɑ郁bZ[W܂
// p[^
//   hwnd:   EBhẼnh
//   nMsg:   bZ[W
//   wParam: bZ[WL̒ǉ
//   lParam: bZ[WL̒ǉ
// ߂l
//   bZ[WɂقȂ܂

EXTERN_C LRESULT WINAPI PluginProc(HWND hwnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
{

	_InitPlugin( hwnd );

	return	0;
}
